using UnityEngine;
using UnityEngine.UI;
using UnityEngine.Events;
using UnityEngine.SceneManagement;
using System.Collections.Generic;
using System.Reflection;

namespace smoketrail
{

    public class smoketrail
    {

        /*
            Welcome to dog shit (AKA. Code)
        */

        public static bool DurationBasedOnFireTime = true;
        public static float DurationSmokeTrail = 2f;

        public static void Main()
        {
            ModAPI.OnItemSpawned += (sender, arguments) => {
                FirearmBehaviour Firearm = arguments.Instance.GetComponent<FirearmBehaviour>();
                if (Firearm)
                {
                    Firearm.gameObject.GetOrAddComponent<FirearmBehaviourSmokeTrail>(); // Using here GetOrAddComponent to avoid duplicating this component when you using Flip heck
                }
            };
            ModAPI.Register( // I first time using C# and Unity + I badly know C# so... Code maybe is disgusting stinky dog shit that even worse than legendary code from Yandere Dev
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Gun Smoke Trails Settings",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "Spawn me to open settings",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("settings_icon.png"),
                    AfterSpawn = (Instance) =>
                    {
                        DialogBox Dialog = new DialogBox();
                        
                        void ShowMain()
                        {
                            Dialog = DialogBoxManager.TextEntry
                            (
                                "What option you want to change?", "",
                                new DialogButton("Duration method", false, (UnityAction)(() => 
                                    {
                                        DurationBasedOnFireTime = !DurationBasedOnFireTime;
                                        if (DurationBasedOnFireTime)
                                        {
                                            ModAPI.Notify("Now smoke trail duration time based on continuous fire");
                                        }
                                        else
                                        {
                                            ModAPI.Notify("Now smoke trial duration time based on set time");
                                        }
                                    })),
                                new DialogButton("Set duration", false, (UnityAction)(() => 
                                    {
                                        if (DurationBasedOnFireTime){ ModAPI.Notify("First change duration method"); return;}
                                        Dialog.Close();
                                        ShowSetDuration();
                                    })),
                                new DialogButton("Exit", false, (UnityAction)(() =>
                                    {
                                        Dialog.Close();
                                    }))
                            );
                            Dialog.ShowTextBox = false;
                        }

                        void ShowSetDuration()
                        {
                            Dialog = DialogBoxManager.TextEntry
                            (
                                "Set duration time", "Please use only numbers",
                                new DialogButton("Set", false, (UnityAction)(() => 
                                    {
                                        float number = float.Parse(Dialog.EnteredText);
                                        DurationSmokeTrail = Mathf.Clamp(number,0,Mathf.Infinity);
                                        ModAPI.Notify("Smoke trail duraiton was succesfully changed to "+number+" seconds");
                                    })),
                                new DialogButton("Back", false, (UnityAction)(() =>
                                    {
                                        Dialog.Close();
                                        ShowMain();
                                    }))
                            );
                            Dialog.ShowTextBox = true;
                        }

                        ShowMain();

                        UnityEngine.Object.Destroy(Instance);
                    }
                }
            );
        }

    }

    public class FirearmBehaviourSmokeTrail : MonoBehaviour
    {
        public FirearmBehaviour Firearm;
        public GameObject Smoke;
        public ParticleSystem SmokeParticle;

        public bool CreatedBefore; // for Flip heck

        public float MinimumTime;
        public float TotalTime;
        public float LastTimeShoot; // maybe teriable solution
        public float TotalShoots;

        public float MaxShootsToSmoke;

        private void FixedUpdate()
        {

            TotalTime += Time.deltaTime;
            float TimeInterval = TotalTime-LastTimeShoot;
            float Duration; // 8 seconds it's maximum
            if (smoketrail.DurationBasedOnFireTime)
            {
                Duration = Mathf.Clamp(TotalShoots/6f,MinimumTime,8f);
            }
            else
            {
                Duration = (MinimumTime/2f)+smoketrail.DurationSmokeTrail;
            }

            bool MoreEqualToMaxShoots = TotalShoots >= MaxShootsToSmoke;

            if (TimeInterval > MinimumTime*0.75f && TimeInterval < Duration && MoreEqualToMaxShoots)
            {
                SmokeParticle.Emit(1);
            }

            if ( (TimeInterval > MinimumTime && TotalShoots > 0 && !(MoreEqualToMaxShoots)) || TimeInterval > Duration && MoreEqualToMaxShoots)
            {
                TotalShoots = 0;
            }
        }

        private void Start()
        {

            Firearm = this.gameObject.GetComponent<FirearmBehaviour>();

            if (Smoke != null && SmokeParticle != null) // reseting particles for Flip Heck
            {
                UnityEngine.Object.Destroy(Smoke);
                UnityEngine.Object.Destroy(SmokeParticle);
            }

            if (Firearm.Automatic)
            {
                MaxShootsToSmoke = Mathf.Clamp(30*Firearm.AutomaticFireInterval,1,12);
                MinimumTime = Firearm.AutomaticFireInterval*MaxShootsToSmoke;
            }
            else
            {
                MaxShootsToSmoke = 3;
                MinimumTime = 0.27f*MaxShootsToSmoke;
            }

            Smoke = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Laser Pointer").Prefab.transform.Find("Smoke").gameObject);
            Smoke.transform.SetParent(this.gameObject.transform);
            Smoke.transform.localPosition = Firearm.barrelPosition;
            SmokeParticle = Smoke.GetComponent<ParticleSystem>();

            //if (CreatedBefore) {return;} // return to stop (and it's too for Flip Heck) // Edit, somehow this shit stopped duplicating Listener
            Firearm.OnFire.AddListener(OnFire);
        }    

        private void OnFire()
        {
            LastTimeShoot = TotalTime;
            TotalShoots += 1;
        }
    }
}
